转诊数据接入
====================

- 作者：Sand，2016.02.18

概述
---------------------

转诊数据是健康档案数据标准的一部分，但转诊数据的采集并非来自医院集成开放平台，而是健康之路的转诊App或其他第三方应用。
遵循统一档案管理原则，转诊数据必须与患者在医疗机构的就诊数据合并，合并时机在接收到集成开放平台的数据之时进行，即二者是异步进行的，
用户实际能看到转诊数据需在健康事件结束后方可查看（出院或门诊结束）。

流程
---------------------

为能够正常接收与合并转诊数据，你可能需要以下几个步骤的流程，以确保转诊数据能够正常与健康档案的数据合并。

- 按[数据内容]()一节准备门诊或住院转诊数据
- 按[档案接收]()文档中的“标准档案包”结构，封装一个转诊数据集（standard与origin目录内容均一样），并使用随机密码加密
- 使用公钥加密随机密码，并与数据包一块上传

### 数据内容

转诊数据需要提供以下内容，并按[标准档案]()封装。

**门诊**

<table>
	<tr>
		<td><b>数据元内部标识</b></td>
		<td><b>数据元名称</b></td>
		<td><b>数据元定义</b></td>
	</tr>
	<tr>
		<td>PATIENT_ID</td>
		<td>病人ID</td>
		<td>医院内信息化系统的病人唯一标识</td>
	</tr>
	<tr>
		<td>HDSD03_01_031</td>
		<td>门诊号（挂号号）</td>
		<td>按照某一特定编码规则赋予门（急）诊就诊对象的顺序号</td>
	</tr>
	<tr>
		<td>HDSD00_01_282</td>
		<td>转出医疗机构名称</td>
		<td>转出的医疗卫生机构的组织机构名称</td>
	</tr>
	<tr>
		<td>HDSD00_01_560</td>
		<td>转出医疗机构代码</td>
		<td>转出机构对应的针对组织机构的特殊编码体系中的代码</td>
	</tr>
	<tr>
		<td>HDSD00_01_283</td>
		<td>转出医疗机构科室名称</td>
		<td>转出医疗机构所属科室名称</td>
	</tr>
	<tr>
		<td>HDSD00_01_284</td>
		<td>转入医疗机构名称</td>
		<td>转入医疗机构的组织机构名称</td>
	</tr>
	<tr>
		<td>JDSC01_05_01</td>
		<td>转入医疗机构代码</td>
		<td>转入机构对应的针对组织机构的特殊编码体系中的代码</td>
	</tr>
	<tr>
		<td>HDSD00_01_285</td>
		<td>转入机构科室名称</td>
		<td>转人的医疗机沟所属科室名称</td>
	</tr>
	<tr>
		<td>HDSD00_01_563</td>
		<td>转诊记录</td>
		<td>对患者转诊过程的描述</td>
	</tr>
	<tr>
		<td>HDSD00_01_564</td>
		<td>转诊日期</td>
		<td>患者转诊当日的公元纪年日期的完整描述</td>
	</tr>
	<tr>
		<td>HDSD00_01_286</td>
		<td>转诊原因</td>
		<td>转诊原因的简要描述</td>
	</tr>
</table>

**住院**

<table>
	<tr>
		<td><b>数据元内部标识</b></td>
		<td><b>数据元名称</b></td>
		<td><b>数据元定义</b></td>
	</tr>
	<tr>
		<td>PATIENT_ID</td>
		<td>病人ID</td>
		<td>医院内信息化系统的病人唯一标识</td>
	</tr>
	<tr>
		<td>HDSD00_01_579</td>
		<td>住院号</td>
		<td>住院者在医疗机构住院的住院号</td>
	</tr>
	<tr>
		<td>HDSD00_01_280</td>
		<td>转出医疗机构名称</td>
		<td>转诊转人的医疗卫生机构的组织机构名称</td>
	</tr>
	<tr>
		<td>HDSD00_01_560</td>
		<td>转出医疗机构代码</td>
		<td>机构对应的针对组织机构的特殊编码体系中的代码</td>
	</tr>
	<tr>
		<td>HDSD00_01_281</td>
		<td>转出医疗机构科室名称</td>
		<td>转诊转人的医疗机沟所属科室名称</td>
	</tr>
	<tr>
		<td>HDSD00_01_282</td>
		<td>转入医疗机构名称</td>
		<td>转诊转人的医疗卫生机构的组织机构名称</td>
	</tr>
	<tr>
		<td>JDSC02_08_01</td>
		<td>转入医疗机构代码</td>
		<td>建档医疗机构经《医疗机构执业许可证》登记的，并按照特定编码体系填写的代码.</td>
	</tr>
	<tr>
		<td>HDSD00_01_283</td>
		<td>转入机构科室名称</td>
		<td>转诊转人的医疗机沟所属科室名称.</td>
	</tr>
	<tr>
		<td>HDSD00_01_563</td>
		<td>转诊记录</td>
		<td>对患者转诊过程的描述.</td>
	</tr>
	<tr>
		<td>HDSD00_01_564</td>
		<td>转诊日期</td>
		<td>患者转诊当日的公元纪年日期的完整描述</td>
	</tr>
	<tr>
		<td>HDSD00_01_285</td>
		<td>转诊原因</td>
		<td>对儿萤转诊原因的简要描述</td>
	</tr>
</table>

API列表
---------------------

### 接收转诊数据包

	POST /package/referral
	
**参数**

<table>
	<tr>
		<td>名称</td>
		<td>类型</td>
		<td>描述</td>
	</tr>
	<tr>
		<td>package</td>
		<td>MultipartHttpServletRequest</td>
		<td>数据包以I/O流的形式提供，名称为：file</td>
	</tr>
	<tr>
		<td>user_name</td>
		<td>string</td>
		<td>用户ID</td>
	</tr>
	<tr>
		<td>package_crypto</td>
		<td>string</td>
		<td>档案包密码，使用公钥加密</td>
	</tr>
	<tr>
		<td>md5</td>
		<td>string</td>
		<td>档案包MD5</td>
	</tr>
</table>
