模块
====================

概述
---------------------

本文档描述EHR平台模块结构。EHR平台使用Maven管理整个工程，包括依赖管理，编译，安装及部署。请先阅读关于Maven工程管理的知识，可以增加下文的理解。

模块及命名
---------------------

EHR平台目前分为四种模块：

- 通用模块，以commons-开头，其它三种模块的基础，包括数据库，实用工具
- 微服务模块，以svr-开头，提供基础服务给网关使用
- 网关模块，以ag-开头，提供微服务聚合，并为应用提供接口
- 应用模块，以app-开头，是EHR平台的应用，如：档案浏览器，总支撑管理

其中，通用模块有两个特殊的对象，属于POM类型，定义工程管理模板。

> ehr-cloud：通用POM模板，管理整个工程的依赖，通用模块并用于Maven Reactor编译

> ehr-ms-parent-pom：微服务应用POM模板，管理整个工程的Spring Boot模块，并用于Maven Reactor编译

**注意：**对于每一个新增的模块

- 如果是通用模块，请在ehr-cloud的pom.xml文件中增加对应的module节点
- 如果是微服务应用，请在ehr-ms-parent-pom的pom.xml文件中增加对应的module节点

按上述方式添加可以统一编译或安装指定的模块。

[模块列表](../commons/modules.html)

编译
---------------------

通用模块与微服务模块分开编译，因为通用模块编译之后还需要安装，而微服务模块不需要再安装。

- 若要编译通用模块，请在IDE或Maven命令中使用install功能调用ehr-cloud模块即可编译好全部模块并安装到本地Maven库。
- 若要编译微服务应用模块，请在IDE或Maven命令中使用Compile调用ehr-ms-parent-pom模块即可编译好全部的模块到模块的Target目录中。

文档
---------------------

EHR平台开发文档分两种：内部文档与外部文档。

- 内部文档你可以看到整个平台的应用结构，开发约定，代码规范，Maven工具及部署方式，部分模块还有业务解释。

- 外部文档用于第三方应用开发，包括业务说明，接口调用方式及开发规范。

### 文档编译

内部文档位于“总支撑管理网关”模块，即ag-admin，通过site:run命令即可编译出来，并在target目录中查看。

外部文档位于“健康档案开放平台”模块，即ag-ehr-platform，通过site:run命令即可编译出来，并在target目录中查看，也会发布到外网。