健康档案资源化方案
====================

> 作者：温富建，2016.03.01
> 参与：罗发强，沈在鑫，李有星，陈维山
> 修订：温富建，2016.03.08

概述
---------------------

在分析问题之前先看两个原则

#### 健康档案数据标准制定原则

> 内部交互，以细粒度数据集为单位，包括数据采集

> 外部交互，以健康档案为单位

> 数据元与数据集只允许增加（在标识命名空间按规定编码），不允许删除，但可以作废

但是在健康档案数据标准0.1版本制作时并未完全遵守此规范，主要具体问题：

- 混合了CDA文档，比如病案首页
- 数据集分配不规范：出院诊断与入院诊断有单独的数据集，但是其他的诊断却没有一个独立的数据集，正常情况是所有的诊断合并为一个数据集

#### 健康档案资源化规则

> 静态数据以数据集为蓝本

> 动态数据根据业务规则生成

二者共同形成资源视图。

#### 面对的问题

当资源化时，由于数据标准的不一致性，无法将数据以简单的规则整合成统一的资源。例如，由于诊断数据在前后版本的数据分散位置不一致，
无法将所有的诊断以同一个数据集的方式统一做整合，又因为对前端应用及用户（患者，医生）而言数据没有版本概念，对外提供数据时不需要加外版本号，
造成无法直接使用资源化的数据。

解决方案
---------------------

根据标准制作规则，数据元的操作结果与资源标准之间的映射存在以下几种结果：

1. 移位：将数据元从一个数据集转移至另一个数据集
2. 合并：将数据元x，y合并为一个数据元z
3. 增加：新建与原来没有的数据元
4. 作废：数据元不再使用
5. 多数据元映射：资源r1与数据元m1，m2映射

分析：

- 2，4情况中与资源之间的映射非常简单，仅使用一对一的映射即可
- 1是将数据元从一个数据集转至另一个数据集，对于两个不同的版本，资源分别与之映射，这种情况与5等同
- 2是将数据元x，y合并成一个数据元z，z可能是新的，也可能取x，y。如果是新的数据元z，那么对两个不同的版本，资源分别与之映射，这种情况与5等同

因此数据元与资源标准之间的映射可以转换为三种情况：

1. 增加：新建与原来没有的数据元
2. 作废：数据元不再使用
3. 多数据元映射：资源r1与数据元m1，m2映射

再分析：

- 新增数据元，只要对资源标准增加一个资源点即可
- 作废数据元，只要对资源点标识为作废即可
- 多数据元映射，只要资源点能够与多个数据元相对应即可

根据以上分析结果，前两个非常简单，可以直接在资源点上与数据元配合处理即可。如果能够解决第三个问题，那资源映射的问题也就可以迎刃而解了。

为了解决第三个问题，我们先分析资源被利用的流程。首先是根据数据标准，按数据集为单位建表，设计主从表模式保存数据，资源与HBase中的字段映射，实现资源的提取。
从数据存储的角度看，可以有不同的方案解决多数据元映射问题。

### 方案一：保留现有表结构，在此之上做视图。

此方案基本结构：将资源视图化，类似对一或多个二维表做视图。此方法的优点是不用在数据归档时对数据做二次清理，保留现有的归档逻辑。当需要数据时，直接使用视图中的
字段提取数据。结构如下：

#### 优点：

- 现有归档与数据存储结构不变（按数据集存储），不用再二次存储
- 资源使用类似Union语法将不同版本（有可能在不同数据集表中）的数据合并起来
- 资源标准只需要与各数据集标准做映射，新增版本时修改视图结构即可适配新的数据标准（类似增加Union操作）
- 应用统一以资源点作为入口即可查询数据，动态查询数据

#### 缺点：

- 视图维护成本可能会非常高，特别是版本非常多的情况下，需要对标准非常熟悉才能维护此视图，一旦出错，数据偏差目前尚不可估计
- 若视图的Union操作效率低（沈在鑫提议），用户体验会非常差

### 方案二：合并所有数据集为一个表存储，多记录列采用主从表记录，在此之上做视图

修改现在数据存储结构，一份档案存储在一条主记录中，以数据集为族，数据元为列存储。若子记录有多条，则扩展一个子表存储。结构如下：


此结构需要对数据进行自动归并操作（或在入库时自动归并），依据是标准之间的差异。即标准发布之后，需要再维护两个标准之间的差异。即如果发生多个同义数据元合并，
那么版本只需要